<?php

/**
*
* AddOn Visited Topic List
*
* @version 1.0.0
* @copyright (c) 2012 Kazekage
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/info_acp_who_visited_a_topic');

if (!$auth->acl_get('u_wvt_list_view')) 
{
trigger_error($user->lang['NO_AUTH'] .'<br><br><a href=' . append_sid('index.php') . '>' . $user->lang['GOTO_INDEX'] . '</a>');
 }

$userid = (int) request_var('id', 0);
$sb = request_var('sb', '');
$so = request_var('so', '');

// Build the pagination
$limit = request_var('limit', $config['topics_per_page']);
$start = request_var('start', 0);
$pagination_url = append_sid($phpbb_root_path . 'visited_topics.' . $phpEx, 'id=' . $userid . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . (($sb) ? '&sb=' . $sb : '') . (($so) ? '&so=' . $so : ''));


if (!$userid) 
{
trigger_error($user->lang['NO_ID'] .'<br><br><a href=' . append_sid('index.php') . '>' . $user->lang['GOTO_INDEX'] . '</a>');
 }
 
 switch ($sb) {
  case 'a':
   $sb= 't.topic_title';
   break;
  case 'b':
   $sb= 'f.forum_name';
   break;
  case 'c':
   $sb= 'tt.view_count';
   break;
  default:
   $sb= 'tt.last_view_time';
   break;  
  }
  if (!$so) {$sb .= ' DESC';} else {$sb .= ' ASC';}
  
$sql = 'SELECT tt.*, t.topic_title, t.topic_id, t.forum_id,  f.forum_id, f.forum_name'.
	' FROM ' . TOPICS_VIEWS_TABLE . ' tt, ' . TOPICS_TABLE . ' t, ' . FORUMS_TABLE . ' f ' .
	' WHERE t.topic_id = tt.topic_id AND f.forum_id = t.forum_id  AND tt.user_id = '. $userid .
	' ORDER BY ' . $sb;
	
$result = $db->sql_query_limit($sql, $limit, $start);


while ($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('memberlist', array(
		'TOPIC_NAME'		=> $row['topic_title'],
		'U_TOPIC'		=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f='. $row['forum_id'] .'&t='. $row['topic_id']),
		'FORUM_NAME'		=> $row['forum_name'],
		'U_FORUM'		=> append_sid("{$phpbb_root_path}viewforum.$phpEx", 'f='. $row['forum_id']),
		'VISITS'		=> $row['view_count'],
		'LAST_VISIT'	=> $user->format_date($row['last_view_time']),
	));
}
unset($row, $sb);
$db->sql_freeresult();

$db->sql_query('SELECT username FROM ' . USERS_TABLE . ' WHERE user_id = ' . $userid);
$username = $db->sql_fetchfield('username');
$db->sql_freeresult();

$db->sql_query('SELECT COUNT(topic_id) as total FROM ' . TOPICS_VIEWS_TABLE . ' WHERE user_id = ' . $userid);
$total = $db->sql_fetchfield('total');
$db->sql_freeresult();

// Send the page header with the page title
page_header(sprintf($user->lang['PAGE_TITLE'], $username));

$template->assign_vars(array(
	'U_SB_TOPIC_NAME'	=> append_sid($phpbb_root_path . 'visited_topics.' . $phpEx, 'id=' . $userid . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=a' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_FORUM_NAME'	=> append_sid($phpbb_root_path . 'visited_topics.' . $phpEx, 'id=' . $userid . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=b' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_VISITS'	=> append_sid($phpbb_root_path . 'visited_topics.' . $phpEx, 'id=' . $userid . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=c' . (($so) ? '&so=0' : '&so=1')),
	'U_SB_LAST_VISIT'	=> append_sid($phpbb_root_path . 'visited_topics.' . $phpEx, 'id=' . $userid . (($limit!=$config['topics_per_page']) ? '&limit=' . $limit : '') . '&sb=b' . (($so) ? '&so=0' : '&so=1')),
	'TITLE'			=> sprintf($user->lang['PAGE_TITLE'], $username),
	'PAGINATION'	=> generate_pagination($pagination_url, $total, $limit, $start),
	'PAGE_NUMBER'	=> on_page($total, $limit, $start),
	'TOTAL'	=> ($total == 1) ? $user->lang['LIST_ELEMENT'] : sprintf($user->lang['LIST_ELEMENTS'], $total),
));

$template->set_filenames(array(
	'body'	=> 'visited_topics.html',
));

// Send the page footer
page_footer(false);

?>